@echo off
:: This backup restoration script was originally developed by Immorpher and scwiba
	
:: Use the registry to find the GOG version of Doom 64
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\GOG.com\Games\1456611261" /v path 2^> nul`) DO (
		set appdir=%%A %%B\
		)
	if exist "%appdir%Doom64.kpf.bak" goto restore
	
:: Use the registry to find the Steam version of Doom 64
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Steam App 1148590" /v InstallLocation 2^> nul`) DO (
		set appdir=%%A %%B\
		)
	if exist "%appdir%Doom64.kpf.bak" goto restore

:: Look for the Epic Games installation of Doom 64
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_CURRENT_USER\System\GameConfigStore\Children\83a5dfb9-5621-47fa-a5e0-a5ead10fa8c3" /v MatchedExeFullPath 2^> nul`) DO (
		set appdir=%%A %%B
		)
		set appdir=%appdir:~0,-14%
	if exist "%appdir%Doom64.kpf.bak" goto restore
	
:: Use the registry to find the Bethesda version of Doom 64
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\DOOM 64\" /v Path 2^> nul`) DO (
		set appdir=%%A %%B\
		)
	if exist "%appdir%Doom64.kpf.bak" goto restore
	
:: Use the registry to find the Game Pass version of Doom 64
	FOR /F "usebackq tokens=3*" %%A IN (`REG QUERY "HKEY_CLASSES_ROOT\Local Settings\Software\Microsoft\Windows\CurrentVersion\AppModel\Repository\Packages\BethesdaSoftworks.Doom641997_2.0.0.0_x64__3275kfvn8vcwc" /v PackageRootFolder 2^> nul`) DO (
		set appdir=%%A %%B\
		)
	if exist "%appdir%Doom64.kpf.bak" goto restore

:: Look for other common directories including locally
	:: Set the directory array
	set appdir=
		if exist "%appdir%Doom64.kpf.bak" goto restore
	set appdir=C:\Program Files\GOG Galaxy\Games\DOOM 64\
		if exist "%appdir%Doom64.kpf.bak" goto restore
	set appdir=C:\Program Files\Steam\steamapps\common\Doom 64\
		if exist "%appdir%Doom64.kpf.bak" goto restore
	set appdir=C:\Program Files\Epic Games\DOOM64\
		if exist "%appdir%Doom64.kpf.bak" goto restore
	set appdir=C:\XboxGames\DOOM 64\Content\
		if exist "%appdir%Doom64.kpf.bak" goto restore
	set appdir=D:\Program Files\GOG Galaxy\Games\DOOM 64\
		if exist "%appdir%Doom64.kpf.bak" goto restore
	set appdir=D:\Program Files\Steam\steamapps\common\Doom 64\
		if exist "%appdir%Doom64.kpf.bak" goto restore
	set appdir=D:\Program Files\Epic Games\DOOM64\
		if exist "%appdir%Doom64.kpf.bak" goto restore
	set appdir=D:\XboxGames\DOOM 64\Content\
		if exist "%appdir%Doom64.kpf.bak" goto restore
		
:: If backups cant be found let user know
	goto notfound


:: If registry is found, restore the backup files
:restore
	:: Doom64.kpf
	copy "%appdir%Doom64.kpf.bak" "%appdir%Doom64.kpf" >NUL
	del "%appdir%Doom64.kpf.bak"
	
	:: BNet.kpf
	copy "%appdir%BNet.kpf.bak" "%appdir%BNet.kpf" >NUL
	del "%appdir%BNet.kpf.bak"
	
	goto :success

:: Cant find the backup Doom 64 files
:notfound
	echo Failed to find the backup files - You'll have to reinstall Doom 64
	pause
	goto :eof

:: Looks like it worked!
:success
	echo Successfully uninstalled - Thanks for playing!
	pause
	goto :eof